function fv.core.Worker.dumpInventory(w)
	local resType = w.resourceInStorage
	local config = fv.core.config
	
	if resType ~= "water" then
		local resCount = w:getResourceCount(resType)
		local barn = findBarnToDeposit(w, w.pos, resType, resCount)
		if barn ~= nil then
			w:addTaskSetHint("@hint_store_res@")
			if w.saddleAnimal then
				goToBuildingWithAnimation(w, barn, "skip")
				w:addTaskDepositInventory(barn, resType, resCount)
			else
				putResourceOptimized(w, barn, resType, resCount)
				w:addTaskPlayAnimation("stay")	
			end
			w:addTaskResetHint()
			return true
		else
			local resType = w.resourceInStorage
			if resType ~= "" and resType ~= "water" then
				local resCount = w:getResourceCount(resType)
				w:addTaskPlayAnimationOnce("sitdown") 
				fv.core.createResourceOut(w.pos+w.dir*config.pathMineLenFinish, resType, resCount, w.uid)
				w:addTaskPlayAnimationOnce("standup")
			end
			w:clearStorage()
		end	
	else
		w:clearStorage()
	end
end	